(**********************************************************************)
(*   Autor   :  Wolfgang Kuhnle                    Datum : 17.2.96    *)
(*   Adresse :  Vaihingen/Enz 2 Schulstrae 58                        *)
(*                                                                    *)
(*              Testprogramm fr Schrittmotor-Interface               *)
(*                                                                    *)
(*   Verwendete Hardware:                                             *)
(*                                                                    *)
(*           -IBM-kompatibler PC                                      *)
(*           -386DX Prozessor 40MHZ                                   *)
(*           -VGA Monitor                                             *)
(*           -Digitalinterface Marke Eigenbau                         *)
(*            12 digitale Eingnge                                    *)
(*            12 digitale Ausgnge                                    *)
(*                                                                    *)
(*   Verwendete Software:                                             *)
(*                                                                    *)
(*           -Turbo-Pascal Version 6.0                                *)
(*                                                                    *)
(*   Programmierbeginn: 17.2.1996                                     *)
(*                                                                    *)
(*   Letzte nderung  :                                               *)
(*                                                                    *)
(**********************************************************************)

program TestSchritt;
uses dos,crt;

           {Konstanten}
           {**********}

const BasisAdrDio = $300;  {Basisadresse Digital-Interface}
const Kontroll    = 145 ;  {Kontrollsignal=Port A=Eingang,B=Ausgang,C untere }
                           {4 Bit auf Eingabe,C obere 4 Bit auf Ausgabe.}
const k_x         = 50  ;  (* 50 schritte pro mm auf x-Achse*)
const k_y         = 50  ;  (* 50 schritte pro mm auf y-Achse*)
const k_z         = 40  ;  (* 40 schritte pro mm auf z-Achse*)
           {bergeordnete Variablen}
           {***********************}
type
   xyz     =record
   x,y,z :boolean;
end;

var
   wahl      : char;
   reset     : byte;
   schalter  : xyz;

           {Zhler zurckstellen}
           {********************}

procedure ResetCounter;

var
   out : byte;
begin
   out := 64;
   port [BasisAdrDio +2] := out;
   delay (200);
   out := 0;
   port [BasisAdrDio +2] := out;
end;

           {Zhler Upper-Lower Byte umschalten}
           {**********************************}

procedure UmschaltCounter;

var
   out : byte;
   inp  : byte;

begin
   inp := port [BasisAdrDio +2];
   if (out <> 0) and (inp <> 16) then
      begin
         out := 16;
         port [BasisAdrDio +2] := out;
         delay (200);
      end;
   if (out <> 16) and (inp = 16) then
      begin
         out := 0;
         port [BasisAdrDio +2] := out;
         delay (200);
      end;
end;

           {Zhler von X- auf Y-Achse umschalten}
           {************************************}

procedure UmschaltXachseYachse;

var
   out : byte;
   inp  : byte;

begin
   inp := port [BasisAdrDio +2];
   if (out <> 0) and (inp <> 32) then
      begin
         out := 32;
         port [BasisAdrDio +2] := out;
         delay (200);
      end;
   if (out <> 32) and (inp = 32) then
      begin
         out := 0;
         port [BasisAdrDio +2] := out;
         delay (200);
      end;
end;


           {Systemzeit in Hundertstel Sekunden holen              }
           {******************************************************}

function zeit:real;
var
  h, m, s, hund : Word;

begin
  GetTime(h,m,s,hund);
  zeit:=((h*24+m)*60+s)*100+hund;
end;

           {Endschalter abfragen und anzeigen (Rechneransteuerung)}
           {******************************************************}

function Endschalter(var schalter:xyz ):boolean;
var hilfsvar: byte;
begin
   (* Annahme: alle Endschalter sind nicht angefahren *)
   schalter.x:=false;
   schalter.y:=false;
   schalter.z:=false;
   (* Vorbelegung: Endschalter ist angefahren und wird, falls nicht
                   angefahren, weiter unten zurueckgesetzt.*)
   endschalter:=true;

   hilfsvar:=port [BasisAdrDio +2];
   hilfsvar:=(hilfsvar mod 5);  (*Kappt die letzten 3 Bit*)
   case hilfsvar of
   4: schalter.x:=true;
   3: schalter.y:=true;
   1: schalter.z:=true;
   else
   (* Kein Endschalter angefahren ansonsten angefahren wie Vorbelegung!*)
   endschalter:=false;
   end;
end;


procedure XZaehler;

var
   sx,sy   :byte;
   lowbyte :byte;
   highbyte:byte;
   Zaehler :word;
begin
      sx := wherex; sy := wherey;
      lowbyte := port [BasisAdrDio+0];
      umschaltcounter;
      highbyte:= port [BasisAdrDio+0];
      umschaltcounter;
      zaehler:=lowbyte+highbyte*256;
      (*clreol;*)
      writeln ('lowbyte ',lowbyte,' highbyte ', Highbyte, ',',zaehler);
      (*gotoxy (sx,sy);*)
end;


           {Z-Achse Takte zhlen und anzeigen (Rechneransteuerung)}
           {*******************************************************}

procedure ZZaehler (var zinp:byte;var zcount : word);

var
   sx,sy  :byte;

begin
   sx := wherex; sy := wherey;
   zinp := port [BasisAdrDio +1];
   if (zinp = 4) or (zinp = 36) then
   inc (zcount);
   clreol;
   write (zcount);
   gotoxy (sx,sy);
end;

function startrampe(z:integer; speed:real): real;
var rampe :byte;
begin
   case abs(z) of
   0:  rampe:=16;
   1:  rampe:=11;
   2:  rampe:=7;
   3:  rampe:=4;
   4:  rampe:=2;
   else
   rampe:=1;
   end;

   if (rampe < speed) then startrampe:=speed else startrampe:=rampe;
end;

function stoprampe(var z:integer; speed:real): real;
var rampe :byte;
    test  :byte;
begin
   (* Drehzahlspruenge abfangen, wenn Rampendrehzahl groesser als Istdrehzahl ist*)
   test:=round(speed);
   if (test > 2) and (z>3) then z:=3;
   if (test > 4) and (z>2) then z:=2;
   if (test > 7) and (z>1) then z:=1;
   if (test > 11) then z:=0;
   case abs(z) of
   0:  rampe:=16;
   1:  rampe:=11;
   2:  rampe:=7;
   3:  rampe:=4;
   4:  rampe:=2;
   else
   rampe:=0;
   end;
   if (rampe < speed) then stoprampe:=speed else stoprampe:=rampe;
end;

procedure Fahren(    speed:real;
                       out:byte;
                     achse:byte);
var t        : real;
    f_schritt: real;
    delta_t  : real;
    z        : integer;
    schritte : integer;
label fahrenabbruch, ende;

begin
      (*Fahren mit eingestellter Geschindigkeit und Richtung solange bis irgendeine Taste gedrueckt wird *)
      z:=0;
      schritte:=0;
      t:=zeit;
      repeat
      begin
         (*startrampe*)
         while Z<5 do
         begin
            inc(z);
            inc(schritte);
            port [BasisAdrDio +1] := out + achse;
            if endschalter(schalter)=true then goto fahrenabbruch;
            delay(round(startrampe(z,speed)));
            port [BasisAdrDio +1] := out ;
         end;
         (*Maximalgeschwindigkeit*)
         begin
            inc(schritte);
            (*xzaehler;*)
            port [BasisAdrDio +1] := out + achse;
            if endschalter(schalter)=true then goto fahrenabbruch;
            delay(round(speed));
            port [BasisAdrDio +1] := out ;
         end;
      end;
      until keypressed;
      Z:=5;
      (*stoprampe*)
      repeat
      begin
         dec(z);
         inc(schritte);
         port [BasisAdrDio +1] := out + achse;
         (*if endschalter(schalter)=true then goto fahrenabbruch;*)
         delay(round(stoprampe(z,speed)));
         port [BasisAdrDio +1] := out ;
      end;
      UNTIL z<=0;
      goto ende;

      fahrenabbruch :
      gotoxy (20,60);
      write(' Endschalter der ');
      if schalter.x=true then writeln ('X-achse angefahren');
      if schalter.y=true then writeln ('Y-achse angefahren');
      if schalter.z=true then writeln ('Z-achse angefahren');
      clreol;
      ende:
end;

           {Hand-Achse fahren}
           {**************}

procedure handFahren;

var
   t         : char;
   tfrequenz : word;
   zeit      : word;
   out       : byte;
   speed     : real;
   xinp      : byte;
   xcount    : word;
   ende      : char;
   Ximp      : integer;
    I        : integer;

begin
   clrscr;
   window (10,5,70,12);
   speed := 50;
   out := 0;
   Writeln('X-Achse............:    Pfeiltasten links.......rechts');
   writeln('Y-Achse............:    Peiltasten  oben........unten');
   writeln('Z-Achse............:    Tasten      PgUp........PGDn');
   writeln('Geschwindigkeit ...:    Tasten      1 (langsam)-9(schnell)');
   writeln('Abbrechen..........;    ESC');

   repeat
      t := Readkey;
      if t=#0 then
      begin
         t:=readkey;
         case t of
            #77 :
               fahren(speed,8,1);
            #75 : (*Fahren X-Achse in negative Richtung*)
               fahren(speed,0,1);
            #72 : (*Fahren y-Achse in positive Richtung*)
               fahren(speed,16,2);
            #80 : (*Fahren Y-Achse in negative Richtung*)
               fahren(speed,0,2);
            #73 : (*Fahren Z-Achse in positive Richtung*)
               fahren(speed,0,4);
            #81 : (*Fahren Z-Achse in negative Richtung*)
               fahren(speed,32,4);
         end;
      end
      else
      begin
         case t of
            #49 : speed:=255;
            #50 : speed:=128;
            #51 : speed:=64;
            #52 : speed:=16;
            #53 : speed:=8;
            #54 : speed:=4;
            #55 : speed:=2;
            #56 : speed:=1.5;
            #57 : speed:=1;
         end;
      end;
    until (t=#27) or (t=#13);
    clrscr;
end;

           {X-Achse fahren}
           {**************}

procedure XachseFahren;

var
   tfrequenz : word;
   zeit      : word;
   out       : byte;
   richtung  : char;
   xinp      : byte;
   xcount    : word;
   ende      : char;
   Ximp      : integer;
    I        : integer;

begin
   clrscr;
   window (20,5,70,12);
   tfrequenz := 0;
   out := 0;
   write ('Taktfrequenz zwischen 1 und 500Hz angeben :');
   readln (zeit);
   write ('mm angeben ');
  textcolor (4) ;highvideo;
   write ('"0"=Dauerlauf! ');
  textcolor (7) ;lowvideo;
   write (':');
   readln (Ximp);
   ximp:=ximp*k_x;
   write ('Drehrichtung Links oder Rechts            :');
   readln (richtung);
    textcolor(4);highvideo;
   writeln ('Stoppen mit "Taste" ');
    textcolor(7);lowvideo;
   write ('Impulse vom Rechner: ');
   if (richtung = #76) or (richtung = #108) then
      out := 8;
   if (richtung = #82) or (richtung = #114) then
      out := 0;
   tfrequenz := 1000 div zeit;
   xcount:= 0;
   I     := 0;
     repeat
      inc (I);
       out := out + 1;
       write(out,' ');
       port [BasisAdrDio +1] := out;
       XZaehler ;
       delay (Tfrequenz);
       out := out - 1;
       writeln(out,' ');
       port [BasisAdrDio +1] := out;
       delay (Tfrequenz);
       until keypressed or (I=Ximp);
       writeln;
       write ('Beenden mit "Enter" ');
       read (ende);
     clrscr;
end;

           {Y-Achse Takte zhlen und anzeigen (Rechneransteuerung)}
           {******************************************************}

procedure YZaehler (var yinp:byte;var ycount : word);

var
   sx,sy  :byte;

begin
   sx := wherex; sy := wherey;
   yinp := port [BasisAdrDio +1];
   if (yinp = 2) or (yinp = 18) then
   inc (ycount);
   clreol;
   write (ycount);
   gotoxy (sx,sy);
end;

           {Y-Achse fahren}
           {**************}

procedure YachseFahren;

var
   tfrequenz : word;
   zeit      : word;
   out       : byte;
   richtung  : char;
   yinp      : byte;
   ycount    : word;
   ende      : char;
   Yimp      : integer;
    I        : integer;

begin
   clrscr;
   window (20,5,70,12);
   tfrequenz := 0;
   out := 0;
   write ('Taktfrequenz zwischen 1 und 500Hz angeben :');
   readln (zeit);
   write ('Anzahl der Impulse angeben ');
  textcolor (4) ;highvideo;
   write ('"0"=Dauerlauf! ');
  textcolor (7) ;lowvideo;
   write (':');
   readln (Yimp);
   yimp:=yimp*k_y;
   write ('Drehrichtung Links oder Rechts            :');
   readln (richtung);
    textcolor(4);highvideo;
   writeln ('Stoppen mit "Taste" ');
    textcolor(7);lowvideo;
   write ('Impulse vom Rechner: ');
   if (richtung = #76) or (richtung = #108) then
      out := 16;
   if (richtung = #82) or (richtung = #114) then
      out := 0;
   tfrequenz := 1000 div zeit;
   ycount:= 0;
   I     := 0;
     repeat
       inc (I);
       out := out + 2;
       port [BasisAdrDio +1] := out;
       YZaehler (yinp,ycount);
       delay (Tfrequenz);
       out := out - 2;
       port [BasisAdrDio +1] := out;
       delay (Tfrequenz);
     until keypressed or (I=Yimp);
       writeln;
       write ('Beenden mit "Enter" ');
       read (ende);
     clrscr;
end;

           {Z-Achse fahren}
           {**************}

procedure ZachseFahren;

var
   tfrequenz : word;
   zeit      : word;
   out       : byte;
   richtung  : char;
   zinp      : byte;
   zcount    : word;
   ende      : char;
   Zimp      : integer;
    I        : integer;

begin
   clrscr;
   window (20,5,70,10);
   tfrequenz := 0;
   out := 0;
   write ('Taktfrequenz zwischen 1 und 500Hz angeben :');
   readln (zeit);
   write ('Anzahl der Impulse angeben ');
  textcolor (4) ;highvideo;
   write ('"0"=Dauerlauf! ');
  textcolor (7) ;lowvideo;
   write (':');
   readln (Zimp);
   zimp:=zimp*k_z;
   write ('Drehrichtung [L]inks oder [R]echts        :');
   readln (richtung);
    textcolor(4);highvideo;
   writeln ('Stoppen mit "Taste" ');
    textcolor(7);lowvideo;
   write ('Impulse vom Rechner: ');
   if (richtung = #76) or (richtung = #108) then
      out := 32;
   if (richtung = #82) or (richtung = #114) then
      out := 0;
   tfrequenz := 1000 div zeit;
   zcount:= 0;
   I     := 0;
     repeat
       inc (I);
       out := out + 4;
       port [BasisAdrDio +1] := out;
       ZZaehler (zinp,zcount);
       delay (Tfrequenz);
       out := out - 4;
       port [BasisAdrDio +1] := out;
       delay (Tfrequenz);
     until keypressed or (I=zimp);
       writeln;
       write ('Beenden mit "Enter" ');
       read (ende);
     clrscr;
end;
           {Prozeduren um Standby-Modus ein- und auszuschalten}
           {**************************************************}

procedure StandByXein;
var
   out : byte;

begin
   out := 64;
   port [BasisAdrDio +1] := out;
end;

procedure StandByXaus;
var
   out : byte;

begin
   out := 0;
   port [BasisAdrDio +1] := out;
end;

procedure StandByYein;
var
   out : byte;

begin
   out := 128;
   port [BasisAdrDio +1] := out;
end;

procedure StandByYaus;
var
   out : byte;

begin
   out := 0;
   port [BasisAdrDio +1] := out;
end;

           {Standby fr X- und Y-Achse ein- und ausschalten}
           {***********************************************}
procedure StandByMode;

var
   auswahl : char;

begin
  clrscr;
  repeat
    window(10,5,78,20); textcolor(15);
    writeln('Bit`s fr die Motorstromreduzierung setzen und rcksetzen');
    writeln('---------------------------------------------------------');
    textcolor(7);
    writeln;
    window(22,7,78,20);
    writeln('<1>    X-und Y-Achse Standby-Modus ein');
    writeln('<2>    X-und Y-Achse Standby-Modus aus');
    writeln('<3>    Port B Bit 7 ein');
    writeln('<4>    Port B Bit 7 aus');
    textcolor(4);highvideo;
    writeln('<E>  Test Beenden'^j);
    textcolor(7);lowvideo;
    write('Whlen Sie: ');
    auswahl:=readkey;
    delline; writeln;
    case auswahl of
      '1':StandByXein;
      '2':StandByXaus;
      '3':StandByYein;
      '4':StandByYaus;
end;
  until (auswahl = #69) or (auswahl = #101);
  window (1,1,80,25);
  clrscr;
end;

           {Umschalten von Joystick-Steuerung auf Automatikbetrieb}
           {******************************************************}

procedure HandBetriebEin;

var
   out   : byte;

begin
   out := 0;
   port [BasisAdrDio +2] := out;
   delay (200);
end;

procedure AutomatikBetriebEin;

var
   out : byte;

begin
   out := 128;
   port [BasisAdrDio +2] := out;
   delay (200);
end;


           {Hauptprogramm}
           {*************}

begin
  port [BasisAdrDio +3] := Kontroll;
  repeat
    clrscr;
    window(20,5,78,20); textcolor(15);
    writeln('Testprogramm fr Schrittmotor-Steuerung');
    writeln('---------------------------------------');
    textcolor(7);
    writeln('<1>    X-Achse fahren');
    writeln('<2>    Y-Achse fahren');
    writeln('<3>    Z-Achse fahren');
    writeln('<4>    Standby Mode');
    writeln('<5>    Handbetrieb');
    writeln('<0>    PC-Steuerung');
    writeln('<6>    Automatikbetrieb');
    writeln('<7>    Reset Counter');
    writeln('<8>    Umschalten von X- auf Y-Zhler <Toggle>');
    writeln('<9>    Umschalten Lower/Higher Byte <Toggle>');
    writeln('<a>    Endschalter pruefen');
    textcolor(4);highvideo;
    writeln('<ESC>  Programm Beenden'^j);
    textcolor(7);lowvideo;
    write('Whlen Sie: ');
    wahl:=readkey;
    delline; writeln;
    case wahl of
      '0': HandFahren;
      '1': Xzaehler;
      '2': YachseFahren;
      '3': ZachseFahren;
      '4': StandByMode;
      '5': HandBetriebEin;
      '6': AutomatikBetriebEin;
      '7': ResetCounter;
      '8': UmschaltXachseYachse;
      '9': UmschaltCounter;
      #27: begin
             clrscr;
             highvideo;
             write('Programm beendet!');
             lowvideo;
             delay(1000);
           end;
    end;
    delline;
  until wahl=#27;
  reset := 0;
  port [BasisAdrDio +1] := reset;
  port [BasisAdrDio +2] := reset;
  window (1,1,80,25);
  clrscr;
end.



